#ifndef lint
static const char gram_sccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <string.h>

#define gram_BYACC 1
#define gram_MAJOR 1
#define gram_MINOR 9
#define gram_PATCH 20090221

#define gram_EMPTY        (-1)
#define gram_clearin      (gram_char = gram_EMPTY)
#define gram_errok        (gram_errflag = 0)
#define gram_RECOVERING() (gram_errflag != 0)

/* compatibility with bison */
#ifdef gram_PARSE_PARAM
/* compatibility with FreeBSD */
#ifdef gram_PARSE_PARAM_TYPE
#define gram_PARSE_DECL() gram_parse(gram_PARSE_PARAM_TYPE gram_PARSE_PARAM)
#else
#define gram_PARSE_DECL() gram_parse(void *gram_PARSE_PARAM)
#endif
#else
#define gram_PARSE_DECL() gram_parse(void)
#endif /* gram_PARSE_PARAM */

extern int gram_PARSE_DECL();

static int gram_growstack(void);
#define gram_PREFIX "gram_"
#line 24 "dns-boot-check/gram.y"

#include <ac/stddef.h>
#include <ac/stdio.h>
#include <ac/stdlib.h>

#include <check.h>
#include <gram.h>
#include <lex.h>
#include <str.h>

#line 46 "dns-boot-check/gram.y"
typedef union {
	string_ty	*lv_string;
} gram_STYPE;
#line 53 "dns-boot-check/gram.y"

void
grammar(const char *filename)
{
	extern int gram_parse(void);

	lex_open(filename);
	gram_parse();
	lex_close();
}

#line 61 "y.tab.c"
#define CACHE 257
#define DIRECTORY 258
#define DOMAIN 259
#define EOLN 260
#define FORWARDERS 261
#define OPTIONS 262
#define PRIMARY 263
#define SECONDARY 264
#define STRING 265
#define gram_ERRCODE 256
static const short gram_lhs[] = {                           -1,
    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    2,    3,    4,    5,    9,    9,   10,    6,    6,
    6,   11,    7,    8,
};
static const short gram_len[] = {                            2,
    0,    3,    0,    1,    1,    1,    1,    1,    1,    1,
    1,    3,    2,    2,    2,    1,    2,    1,    2,    2,
    2,    1,    3,    3,
};
static const short gram_defred[] = {                         1,
    0,   11,    0,    0,    0,    0,    0,    0,    0,    0,
    4,    5,    6,    7,    0,    9,   10,    0,   13,   14,
   18,    0,   16,   22,   19,    0,    0,    2,   21,   20,
   12,   17,   23,   24,
};
static const short gram_dgoto[] = {                          1,
   10,   11,   12,   13,   14,   15,   16,   17,   22,   23,
   25,
};
static const short gram_sindex[] = {                         0,
 -251,    0, -264, -263, -262, -261, -250, -249, -248, -246,
    0,    0,    0,    0, -256,    0,    0, -247,    0,    0,
    0, -261,    0,    0,    0, -245, -244,    0,    0,    0,
    0,    0,    0,    0,
};
static const short gram_rindex[] = {                         0,
 -241,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -238,    0,    0,    0,    0,    0,
    0, -237,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,
};
static const short gram_gindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    2,
   10,
};
#define gram_TABLESIZE 25
static const short gram_table[] = {                         29,
   18,   19,   20,   21,    2,    3,    4,    5,   24,    6,
    7,    8,    9,   28,   24,   26,   27,   31,    3,   33,
   34,    8,   15,   32,   30,
};
static const short gram_check[] = {                        256,
  265,  265,  265,  265,  256,  257,  258,  259,  265,  261,
  262,  263,  264,  260,  265,  265,  265,  265,  260,  265,
  265,  260,  260,   22,   15,
};
#define gram_FINAL 1
#ifndef gram_DEBUG
#define gram_DEBUG 0
#endif
#define gram_MAXTOKEN 265
#if gram_DEBUG
static const char *gram_name[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"CACHE","DIRECTORY","DOMAIN",
"EOLN","FORWARDERS","OPTIONS","PRIMARY","SECONDARY","STRING",
};
static const char *gram_rule[] = {
"$accept : main",
"main :",
"main : main directive EOLN",
"directive :",
"directive : cache",
"directive : directory",
"directive : domain",
"directive : forwarders",
"directive : option",
"directive : primary",
"directive : secondary",
"directive : error",
"cache : CACHE STRING STRING",
"directory : DIRECTORY STRING",
"domain : DOMAIN STRING",
"forwarders : FORWARDERS ip_address_list",
"ip_address_list : ip_address",
"ip_address_list : ip_address_list ip_address",
"ip_address : STRING",
"option : OPTIONS option_string",
"option : option option_string",
"option : option error",
"option_string : STRING",
"primary : PRIMARY STRING STRING",
"secondary : SECONDARY STRING STRING",

};
#endif
#if gram_DEBUG
#endif

/* define the initial stack-sizes */
#ifdef gram_STACKSIZE
#undef gram_MAXDEPTH
#define gram_MAXDEPTH  gram_STACKSIZE
#else
#ifdef gram_MAXDEPTH
#define gram_STACKSIZE gram_MAXDEPTH
#else
#define gram_STACKSIZE 500
#define gram_MAXDEPTH  500
#endif
#endif

#define gram_INITSTACKSIZE 500

int      gram_debug;
int      gram_nerrs;
int      gram_errflag;
int      gram_char;
short   *gram_ssp;
gram_STYPE *gram_vsp;
gram_STYPE  gram_val;
gram_STYPE  gram_lval;

/* variables for the parser stack */
static short   *gram_ss;
static short   *gram_sslim;
static gram_STYPE *gram_vs;
static unsigned gram_stacksize;
/* allocate initial stack or double stack size, up to gram_MAXDEPTH */
static int gram_growstack(void)
{
    int i;
    unsigned newsize;
    short *newss;
    gram_STYPE *newvs;

    if ((newsize = gram_stacksize) == 0)
        newsize = gram_INITSTACKSIZE;
    else if (newsize >= gram_MAXDEPTH)
        return -1;
    else if ((newsize *= 2) > gram_MAXDEPTH)
        newsize = gram_MAXDEPTH;

    i = gram_ssp - gram_ss;
    newss = (gram_ss != 0)
          ? (short *)realloc(gram_ss, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    gram_ss  = newss;
    gram_ssp = newss + i;
    newvs = (gram_vs != 0)
          ? (gram_STYPE *)realloc(gram_vs, newsize * sizeof(*newvs))
          : (gram_STYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    gram_vs = newvs;
    gram_vsp = newvs + i;
    gram_stacksize = newsize;
    gram_sslim = gram_ss + newsize - 1;
    return 0;
}

#define gram_ABORT  goto gram_abort
#define gram_REJECT goto gram_abort
#define gram_ACCEPT goto gram_accept
#define gram_ERROR  goto gram_errlab

int
gram_PARSE_DECL()
{
    int gram_m, gram_n, gram_state;
#if gram_DEBUG
    const char *gram_s;

    if ((gram_s = getenv("gram_DEBUG")) != 0)
    {
        gram_n = *gram_s;
        if (gram_n >= '0' && gram_n <= '9')
            gram_debug = gram_n - '0';
    }
#endif

    gram_nerrs = 0;
    gram_errflag = 0;
    gram_char = gram_EMPTY;
    gram_state = 0;

    if (gram_ss == NULL && gram_growstack()) goto gram_overflow;
    gram_ssp = gram_ss;
    gram_vsp = gram_vs;
    gram_state = 0;
    *gram_ssp = 0;

gram_loop:
    if ((gram_n = gram_defred[gram_state]) != 0) goto gram_reduce;
    if (gram_char < 0)
    {
        if ((gram_char = gram_lex()) < 0) gram_char = 0;
#if gram_DEBUG
        if (gram_debug)
        {
            gram_s = 0;
            if (gram_char <= gram_MAXTOKEN) gram_s = gram_name[gram_char];
            if (!gram_s) gram_s = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    gram_PREFIX, gram_state, gram_char, gram_s);
        }
#endif
    }
    if ((gram_n = gram_sindex[gram_state]) && (gram_n += gram_char) >= 0 &&
            gram_n <= gram_TABLESIZE && gram_check[gram_n] == gram_char)
    {
#if gram_DEBUG
        if (gram_debug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    gram_PREFIX, gram_state, gram_table[gram_n]);
#endif
        if (gram_ssp >= gram_sslim && gram_growstack())
        {
            goto gram_overflow;
        }
        gram_state = gram_table[gram_n];
        *++gram_ssp = gram_table[gram_n];
        *++gram_vsp = gram_lval;
        gram_char = gram_EMPTY;
        if (gram_errflag > 0)  --gram_errflag;
        goto gram_loop;
    }
    if ((gram_n = gram_rindex[gram_state]) && (gram_n += gram_char) >= 0 &&
            gram_n <= gram_TABLESIZE && gram_check[gram_n] == gram_char)
    {
        gram_n = gram_table[gram_n];
        goto gram_reduce;
    }
    if (gram_errflag) goto gram_inrecovery;

    gram_error("syntax error");

    goto gram_errlab;

gram_errlab:
    ++gram_nerrs;

gram_inrecovery:
    if (gram_errflag < 3)
    {
        gram_errflag = 3;
        for (;;)
        {
            if ((gram_n = gram_sindex[*gram_ssp]) && (gram_n += gram_ERRCODE) >= 0 &&
                    gram_n <= gram_TABLESIZE && gram_check[gram_n] == gram_ERRCODE)
            {
#if gram_DEBUG
                if (gram_debug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", gram_PREFIX, *gram_ssp, gram_table[gram_n]);
#endif
                if (gram_ssp >= gram_sslim && gram_growstack())
                {
                    goto gram_overflow;
                }
                gram_state = gram_table[gram_n];
                *++gram_ssp = gram_table[gram_n];
                *++gram_vsp = gram_lval;
                goto gram_loop;
            }
            else
            {
#if gram_DEBUG
                if (gram_debug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            gram_PREFIX, *gram_ssp);
#endif
                if (gram_ssp <= gram_ss) goto gram_abort;
                --gram_ssp;
                --gram_vsp;
            }
        }
    }
    else
    {
        if (gram_char == 0) goto gram_abort;
#if gram_DEBUG
        if (gram_debug)
        {
            gram_s = 0;
            if (gram_char <= gram_MAXTOKEN) gram_s = gram_name[gram_char];
            if (!gram_s) gram_s = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    gram_PREFIX, gram_state, gram_char, gram_s);
        }
#endif
        gram_char = gram_EMPTY;
        goto gram_loop;
    }

gram_reduce:
#if gram_DEBUG
    if (gram_debug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                gram_PREFIX, gram_state, gram_n, gram_rule[gram_n]);
#endif
    gram_m = gram_len[gram_n];
    if (gram_m)
        gram_val = gram_vsp[1-gram_m];
    else
        memset(&gram_val, 0, sizeof gram_val);
    switch (gram_n)
    {
case 12:
#line 87 "dns-boot-check/gram.y"
	{
			check_cache(gram_vsp[-1].lv_string, gram_vsp[0].lv_string);
			str_free(gram_vsp[-1].lv_string);
			str_free(gram_vsp[0].lv_string);
		}
break;
case 13:
#line 96 "dns-boot-check/gram.y"
	{
			check_directory(gram_vsp[0].lv_string);
			str_free(gram_vsp[0].lv_string);
		}
break;
case 14:
#line 104 "dns-boot-check/gram.y"
	{
			check_domain(gram_vsp[0].lv_string);
			str_free(gram_vsp[0].lv_string);
		}
break;
case 18:
#line 121 "dns-boot-check/gram.y"
	{
			check_forwarder(gram_vsp[0].lv_string);
			str_free(gram_vsp[0].lv_string);
		}
break;
case 22:
#line 135 "dns-boot-check/gram.y"
	{
			check_option(gram_vsp[0].lv_string);
			str_free(gram_vsp[0].lv_string);
		}
break;
case 23:
#line 143 "dns-boot-check/gram.y"
	{
			check_primary(gram_vsp[-1].lv_string, gram_vsp[0].lv_string);
			str_free(gram_vsp[-1].lv_string);
			str_free(gram_vsp[0].lv_string);
		}
break;
case 24:
#line 152 "dns-boot-check/gram.y"
	{
			check_secondary(gram_vsp[-1].lv_string, gram_vsp[0].lv_string);
			str_free(gram_vsp[-1].lv_string);
			str_free(gram_vsp[0].lv_string);
		}
break;
#line 434 "y.tab.c"
    }
    gram_ssp -= gram_m;
    gram_state = *gram_ssp;
    gram_vsp -= gram_m;
    gram_m = gram_lhs[gram_n];
    if (gram_state == 0 && gram_m == 0)
    {
#if gram_DEBUG
        if (gram_debug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", gram_PREFIX, gram_FINAL);
#endif
        gram_state = gram_FINAL;
        *++gram_ssp = gram_FINAL;
        *++gram_vsp = gram_val;
        if (gram_char < 0)
        {
            if ((gram_char = gram_lex()) < 0) gram_char = 0;
#if gram_DEBUG
            if (gram_debug)
            {
                gram_s = 0;
                if (gram_char <= gram_MAXTOKEN) gram_s = gram_name[gram_char];
                if (!gram_s) gram_s = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        gram_PREFIX, gram_FINAL, gram_char, gram_s);
            }
#endif
        }
        if (gram_char == 0) goto gram_accept;
        goto gram_loop;
    }
    if ((gram_n = gram_gindex[gram_m]) && (gram_n += gram_state) >= 0 &&
            gram_n <= gram_TABLESIZE && gram_check[gram_n] == gram_state)
        gram_state = gram_table[gram_n];
    else
        gram_state = gram_dgoto[gram_m];
#if gram_DEBUG
    if (gram_debug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", gram_PREFIX, *gram_ssp, gram_state);
#endif
    if (gram_ssp >= gram_sslim && gram_growstack())
    {
        goto gram_overflow;
    }
    *++gram_ssp = (short) gram_state;
    *++gram_vsp = gram_val;
    goto gram_loop;

gram_overflow:
    gram_error("yacc stack overflow");

gram_abort:
    return (1);

gram_accept:
    return (0);
}
