/*
 *      dnsutl - utilities to make DNS easier to configure
 *      Copyright (C) 1996, 1999, 2006 Peter Miller;
 *      All rights reserved.
 *
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111, USA.
 *
 * MANIFEST: functions to manipulate auxs
 */

#include <srrf.h>


void
srrf_invoke_aux1(srrf_t *rp, void *arg)
{
    if (rp && rp->type && rp->type->aux1)
	rp->type->aux1(rp, arg);
}


void
srrf_invoke_aux2(srrf_t *rp, void *arg)
{
    if (rp && rp->type && rp->type->aux2)
	rp->type->aux2(rp, arg);
}
